Imports System.Data.sqlclient
Imports datagridviewTotal.DataSet1TableAdapters

Public Class Form1

    Private Sub Button1_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button1.Click

        'define a string de conexao
        Dim connStr As String = _
           "Data Source=.\SQLEXPRESS;Initial Catalog=Northwind;Integrated Security=True"

        'define a instruo sql
        Dim sql As String = "SELECT * FROM Customers"

        'define os objetos connecton, command e dataadapter
        Dim conn As SqlConnection = New SqlConnection(connStr)
        Dim comm As SqlCommand = New SqlCommand(sql, conn)
        Dim dataadapter As SqlDataAdapter = New SqlDataAdapter(comm)
        'define o dataset
        Dim ds As DataSet = New DataSet()
        Try
            '---abre a conexao---
            conn.Open()

            '---preenche o dataset---
            dataadapter.Fill(ds, "Clientes")
            '---fecha a conexao---
            conn.Close()

            '---vincula o dataset ao DataGridView---
            DataGridView1.DataSource = ds
            'DataGridView1.AutoResizeColumns(DataGridViewAutoSizeColumnsMode.DisplayedCells)

            '---define a tabela a ser exibida---
            DataGridView1.DataMember = "Clientes"
        Catch ex As Exception
            MsgBox(ex.Message)
        End Try
    End Sub

    Private Sub DataGridView1_CellEnter(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) Handles DataGridView1.CellEnter
        ''---Quando o usurio clicar no controle , exibe o conteudo da clula
        'MsgBox(DataGridView1.Rows(e.RowIndex).Cells(e.ColumnIndex).Value)
        'MsgBox(DataGridView1.Rows(e.RowIndex).Cells(0).Value)
    End Sub

    Private Sub dataGridView1_CellValidating(ByVal sender As Object, ByVal e As DataGridViewCellValidatingEventArgs) _
    Handles DataGridView1.CellValidating

        ' Valida o entrada para o CompanyName no permitindo valores em branco
        If DataGridView1.Columns(e.ColumnIndex).Name = "CompanyName" Then
            If String.IsNullOrEmpty(e.FormattedValue.ToString()) Then
                DataGridView1.Rows(e.RowIndex).ErrorText = "O nome da Companhia no pode ser vazio."
                e.Cancel = True
            End If
        End If

    End Sub

    Private Sub dataGridView1_CellEndEdit(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellEventArgs) _
        Handles DataGridView1.CellEndEdit

        ' Limpa o erro da linha no caso do usurio pressionar ESC
        DataGridView1.Rows(e.RowIndex).ErrorText = String.Empty

    End Sub
    Private Sub dataGridView1_DataError(ByVal sender As Object, ByVal e As DataGridViewDataErrorEventArgs) _
        Handles DataGridView1.DataError

        ' Se a fonte de dados levanta uma exceo quando uma clula esta comitda exibe um erro.
        If e.Exception IsNot Nothing AndAlso e.Context = DataGridViewDataErrorContexts.Display Then
            MessageBox.Show("O cdigo do cliente - CustomerID - no pode ser duplicado.")
        End If

    End Sub

    Private Sub dataGridView1_CellPainting(ByVal sender As Object, ByVal e As System.Windows.Forms.DataGridViewCellPaintingEventArgs) _
    Handles DataGridView1.CellPainting

        If Me.DataGridView1.Columns("ContactName").Index = e.ColumnIndex AndAlso e.RowIndex >= 0 Then

            Dim newRect As New Rectangle(e.CellBounds.X + 1, e.CellBounds.Y + 1, e.CellBounds.Width - 4, e.CellBounds.Height - 4)
            Dim backColorBrush As New SolidBrush(e.CellStyle.BackColor)
            Dim gridBrush As New SolidBrush(Me.DataGridView1.GridColor)
            Dim gridLinePen As New Pen(gridBrush)

            Try

                ' apaga a celula.
                e.Graphics.FillRectangle(backColorBrush, e.CellBounds)

                ' Desenha linhas (somente a direita e na base);
                e.Graphics.DrawLine(gridLinePen, e.CellBounds.Left, e.CellBounds.Bottom - 1, e.CellBounds.Right - 1, e.CellBounds.Bottom - 1)
                e.Graphics.DrawLine(gridLinePen, e.CellBounds.Right - 1, e.CellBounds.Top, e.CellBounds.Right - 1, e.CellBounds.Bottom)

                ' desenha o efeito nas linhas
                e.Graphics.DrawRectangle(Pens.Blue, newRect)

                ' Desenha o conteudo da celula sem alinhamento
                If (e.Value IsNot Nothing) Then
                    e.Graphics.DrawString(CStr(e.Value), e.CellStyle.Font, Brushes.Crimson, e.CellBounds.X + 2, e.CellBounds.Y + 2, StringFormat.GenericDefault)
                End If
                e.Handled = True

            Finally
                gridLinePen.Dispose()
                gridBrush.Dispose()
                backColorBrush.Dispose()
            End Try

        End If

    End Sub

    Private Sub Form1_Load(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles MyBase.Load
        '       Me.DataGridView1.Dock = DockStyle.Fill
    End Sub

    Private Sub Button2_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button2.Click

        '---crria uma instncia de um tableadapter ---
        Dim adapter As New CustomersTableAdapter

        '---cria uma instncia de um dataview---
        Dim dv As New DataView(adapter.GetData)

        'filtra usando o criterio escolhido: clientes com cdigo contendo B no incio 
        With dv
            .AllowNew = False
            .AllowDelete = True
            .Sort = "ContactTitle ASC, Address ASC"
            .RowFilter = "CustomerID LIKE 'B*'"
        End With
        DataGridView1.DataSource = dv

    End Sub
    Private Sub Button3_Click(ByVal sender As System.Object, ByVal e As System.EventArgs) Handles Button3.Click
        DataGridView1.Sort(DataGridView1.Columns(0), System.ComponentModel.ListSortDirection.Descending)
    End Sub
    'Define o texto da propriedade ToolTip para clulas da coluna especificada , no caso a coluna: City
    Sub dataGridView1_CellFormatting(ByVal sender As Object, _
        ByVal e As DataGridViewCellFormattingEventArgs) _
        Handles DataGridView1.CellFormatting

        If e.ColumnIndex = Me.DataGridView1.Columns("City").Index AndAlso (e.Value IsNot Nothing) Then

            With Me.DataGridView1.Rows(e.RowIndex).Cells(e.ColumnIndex)

                If e.Value.Equals("London") Then
                    .ToolTipText = "< Inglaterra >"
                ElseIf e.Value.Equals("Sao Paulo") Then
                    .ToolTipText = "< Brasil > "
                ElseIf e.Value.Equals("Madrid") Then
                    .ToolTipText = "< Espanha >"
                ElseIf e.Value.Equals("Buenos Aires") Then
                    .ToolTipText = "< Argentina >"
                End If

            End With

        End If

    End Sub
End Class
